#include <dos.h>
#if defined(LSI_C)
char _asm_cli(char *);
char _asm_sti(char *);
#define cli() _asm_cli("\n\tCLI\n")
#define sti() _asm_sti("\n\tSTI\n")
#endif
#if defined(__TURBOC__)
#include <conio.h>
#define cli disable
#define sti enable
#endif
#include <stdio.h>

int is152402 = 0;
int is152403 = 0;
unsigned char far *chklo;
unsigned char far *chkhi;

int
check_a20_enabled(void)
{
    int rc;
    unsigned char b_cl, b_ch;
    cli();
    b_cl = *chklo;
    b_ch = *chkhi;
    *chklo = 0x55;
    *chkhi = 0xaa;
    rc = (*chklo == 0x55 && *chkhi == 0xaa);
    *chkhi = b_ch;
    *chklo = b_cl;
    sti();
    return rc;
}


void
wait_kbd_inb(void)
{
    while(inp(0x64) & 2);
}

void
wait_kbd_inbfull(void)
{
    while(!(inp(0x64) & 2));
}

void
wait_kbd_outb(void)
{
    while(inp(0x64) & 1);
}

void
flush_kbd_outb(void)
{
    while(inp(0x64) & 1) {
        inp(0x60);
    }
}

void
wait_kbd_outbfull(void)
{
    while(!(inp(0x64) & 1));
}


unsigned char
send_cmd_result(unsigned char cmd)
{
    unsigned char r;
    
    cli();
    
    wait_kbd_inb();
    
    outp(0x64, cmd);
    wait_kbd_inb(); /* wait for recognizing command */
    wait_kbd_outbfull(); /* wait for result... */
    r = inp(0x60);
    
    sti();
    return r;
}

void
send_cmd_with_param(unsigned char cmd, unsigned char param)
{
    cli();
    wait_kbd_inb();
    outp(0x64, cmd);
    wait_kbd_inb(); /* wait for recognizing command */
    outp(0x60, param);
    wait_kbd_outb();
    sti();
    return ;
}

unsigned char
query_a20_kbd(void)
{
    return send_cmd_result(0xd0);
}

void
set_a20_kbd(unsigned char v)
{
   send_cmd_with_param(0xd1, v | 1);
}


int
query_a20_bios(void)
{
    union REGS r;
    r.x.ax = 0x2402;
    int86(0x15, &r, &r);
    
    return r.x.ax;
}

void
put_a20stat(FILE *fo)
{
    unsigned char k, p;
    union REGS r;
    
    r.x.ax = 0x2402;
    int86(0x15, &r, &r);
    fprintf(fo, "int15-2402:%04x", r.x.ax);
    if (r.h.ah == 0) fprintf(fo, "(%d) ", r.h.al & 1);
    else fprintf(fo, "(?) ");
    k = query_a20_kbd();
    p = inp(0x92);
    fprintf(fo, "KBDout:%02x(%d), port92:%02x(%d)", k, (k & 2) >> 1, p, (p & 2)>>1);
    fprintf(fo, " A20:%s", check_a20_enabled() ? "enabled" : "disabled");
    fprintf(fo, "\n");
}


void
main(void)
{
    union REGS r;
    struct SREGS sr;
    unsigned long np, np2;
    unsigned nps, npo, np2o;
    
    r.h.ah = 0x52;
    intdosx(&r, &r, &sr);
    nps = sr.es; npo = r.x.bx + 0x22 + 10 + 7; /* bottom of "NUL     " */
    np = ((unsigned long)nps << 4) + npo;
    if (np > 0xffffUL) {
        printf("NUL header is placed at higer address (more than 0xffff).\n");
        exit(1);
    }
    np2 = np +  0x100000;
    np2o = (np - 0xffff0);
    chklo = MK_FP(nps, npo);
    chkhi = MK_FP(0xffffU, np2o);
    
    r.x.ax = 0x2402;
    int86(0x15, &r, &r);
    is152402 = (r.h.ah != 0x86 && r.h.ah != 0x24);
    r.x.ax = 0x2403;
    r.x.bx = 0;
    int86(0x15, &r, &r);
    is152403 = (r.h.ah == 0);
    
    printf("int 15h,ax=2402h is %ssupported.\n", is152402 ? "" : "not ");
    printf("int 15h,ax=2403h is %ssupported.", is152403 ? "" : "not ");
    if (is152403) printf(" (bx=%04x)", r.x.bx);
    printf("\n");
    
    printf("initial value\n");
    put_a20stat(stdout);
    
    printf("A20(Keyboard) on\n");
    set_a20_kbd(0xdf);
    put_a20stat(stdout);
    printf("A20(Keyboard) off\n");
    set_a20_kbd(0xdd);
    put_a20stat(stdout);
    
    printf("A20(port92h) on\n");
    outp(0x92, (inp(0x92) | 2) & 0xfe);
    put_a20stat(stdout);
    printf("A20(port92h) off\n");
    outp(0x92, inp(0x92) & 0xfc);
    put_a20stat(stdout);
    
    printf("A20(Keyboard) off -> A20(port92h) on\n");
    set_a20_kbd(0xdd);
    outp(0x92, (inp(0x92) | 2) & 0xfe);
    put_a20stat(stdout);
    printf("A20(Keyboard) on -> A20(port92h) off\n");
    set_a20_kbd(0xdf);
    outp(0x92, inp(0x92) & 0xfc);
    put_a20stat(stdout);
    printf("A20(Keyboard) on -> A20(port92h) on\n");
    set_a20_kbd(0xdf);
    outp(0x92, (inp(0x92) | 2) & 0xfe);
    put_a20stat(stdout);
    printf("A20(Keyboard) off -> A20(port92h) off\n");
    set_a20_kbd(0xdd);
    outp(0x92, inp(0x92) & 0xfc);
    put_a20stat(stdout);
    
    
    printf("int 15h,ax=2401h (A20 on)...");
    r.x.ax = 0x2401;
    int86(0x15, &r, &r);
    if (r.h.ah == 0) printf("success\n");
    else printf("failure (%02xh%s)\n", r.h.ah, (r.h.ah == 0x86 || r.h.ah == 0x24) ? "...not supported" : "");
    put_a20stat(stdout);
    printf("int 15h,ax=2400h (A20 off)...");
    r.x.ax = 0x2400;
    int86(0x15, &r, &r);
    if (r.h.ah == 0) printf("success\n");
    else printf("failure (%02xh%s)\n", r.h.ah, (r.h.ah == 0x86 || r.h.ah == 0x24) ? "...not supported" : "");
    put_a20stat(stdout);
}
